//mod_d3d9vsync	v1.0	for HSP3	2013/04/13
#module "mod_d3d9vsync"
#uselib "d3d9"
#cfunc Direct3DCreate9 "Direct3DCreate9" int
#usecom IDirect3D9 "{81BDCBCA-64D4-426d-AE8D-AD0147F4275C}"
#comfunc D3D9_GetAdapterDisplayMode	8	int, int
#comfunc D3D9_GetDeviceCaps			14	int ,int,int,int
#comfunc D3D9_CreateDevice			16	int, int, int, int, int, int

#usecom IDirect3DDevice9 "{D0223B96-BF7A-43fd-92BD-A43B0D82B9EB}"
#comfunc D3D9_TestCooperativeLevel 3
#comfunc IDirect3DDevice9_GetRasterStatus	19	int,int
#comfunc _D3DDV9_Reset	16	int

#define D3DDEVTYPE_HAL	1
#define D3DDEVTYPE_REF  2
#define D3DDEVTYPE_SW  3
#define D3DDEVTYPE_NULLREF  4

#define D3DSWAPEFFECT_DISCARD	1
#define D3DSWAPEFFECT_FLIP  2
#define D3DSWAPEFFECT_COPY  3
#define D3DSWAPEFFECT_FORCE_DWORD  0xFFFFFFF

#define D3DCREATE_HARDWARE_VERTEXPROCESSING 0x00000040
#define D3DCREATE_SOFTWARE_VERTEXPROCESSING 0x00000020

#define DDCAPS_READSCANLINE   0x00020000

#define D3DCREATE_FPU_PRESERVE   0x00000002
#define D3DCREATE_MULTITHREADED  0x00000004

#define D3D_SDK_VERSION 32
#define ctype D3DPS_VERSION(%1,%2) (0xFFFF0000|((%1)<<8)|(%2))
#define ctype D3DVS_VERSION(%1,%2) (0xFFFE0000|((%1)<<8)|(%2))
#define ctype D3DVP_VERSION(%1) (((((%1))>>8)&$ff)),((%1&$ff))

#uselib "KERNEL32.DLL"
#func  _Sleep "Sleep" sptr
#uselib "winmm.dll"
#cfunc _timeGetTime "timeGetTime"
#func _timeBeginPeriod "timeBeginPeriod" sptr
#func _timeEndPeriod "timeEndPeriod" sptr

#define global  d3d9vsync_GetTime	_timeGetTime@mod_d3d9vsync() //PCN̎Ԃ~bŕԂ

#define global D3D9WIN_ID			9999 //D3D9_CreateDevicepEBhEID
#define global d3d9vsync_cpu		cpu@mod_d3d9vsync //1t[CPUgp
#define global d3d9vsync_cpu10 		cpu10@mod_d3d9vsync //10t[CPUώgp
#define global d3d9vsync_ptime 		Processing_time@mod_d3d9vsync //1t[̏
#define global d3d9vsync_fps 		fps@mod_d3d9vsync //1bԂ̃t[
#define global d3d9vsync_ftime 		fps_time@mod_d3d9vsync //1t[̎gpł鎞

#define global d3d9vsync_err 		d3d9err@mod_d3d9vsync //D3DERR

//d3d9vsync_set_RefreshRate ݂̃tbV[g
//d3d9vsync_initɃtbV[gύXꂽꍇ̍ŏp
#define global d3d9vsync_set_RefreshRate(%1=-1)	_d3d9vsync_set_RefreshRate %1 
#deffunc  _d3d9vsync_set_RefreshRate int RR
	if RR>0 {set_RefreshRate=RR:D3DDV9_Reset}else{set_RefreshRate=RefreshRate}
return RefreshRate

//D3DDV9_Reset
//D3DDV9Zbg
#deffunc  D3DDV9_Reset
	if (vsyncoff\2)=0 {
		D3D9_GetAdapterDisplayMode objd3d, 0, varptr(D3DFORMAT)	
		if D3DFORMAT(2)>0 {RefreshRate=D3DFORMAT(2)}else{RefreshRate=set_RefreshRate}
		_D3DDV9_Reset objd3ddv,varptr(d3dpp)
		vsyncon=bak_vsyncon
		vsyncoff=0
		if (set_fps = RefreshRate) {vsyncon=0}else{if vsyncon=0 {vsyncoff=2} }
		gosub  *timeinit
	}
return

//RasterAdjust Cl
//tXN[̑ĎʒuC Clȗ20iŏIC20ȎĎ,tbV[g60Y𑜓x1080̏ꍇj
//ClȗꍇstatɌ݂̐ݒlԂ
#define global RasterAdjust(%1=Raster_adjust@mod_d3d9vsync) _RasterAdjust %1 
#deffunc _RasterAdjust int p1 
	Raster_adjust=p1
return Raster_adjust

//d3d9vsync_init t[[g , Ď[hDtO
//d3d9e평 t[[gȗ60i0ȉw肷ƃtbV[ggj
//tbV[gDtOF1̎t[[gƃtbV[gĂĎ[hݒ
#define global d3d9vsync_init(%1=60,%2=0)	vsyncon@mod_d3d9vsync=%2:_d3d9vsync_init %1
#deffunc  _d3d9vsync_init int _set_fps
	bak_ID = ginfo(3)
	Target_ID=bak_ID
	mref BMSCR,67
	if (BMSCR(17) = 1) {}
	if set_RefreshRate<=0 {set_RefreshRate=60}
	bak_vsyncon=vsyncon
	desktop_sizey=ginfo(21)
	if set_fps {d3d9vsync_end}//ďꂽꍇd3d9vsync_ends
	_timeBeginPeriod 1	:	tBP=1
	RefreshRate=set_RefreshRate //Ƃ肠tbV[g60ɂƂ
	if _set_fps<=0 {set_fps=60}else{set_fps=_set_fps}
	Raster_adjust=0 //tXN[̑ĎʒuCl
	Sleep_adjust_full=1 //tXN[X[vCl
	dim D3DFORMAT, 4	
	dim D3DCAPS9,128	
	dim RasterStatus,2
	d3dpp = 0, 0, D3DFORMAT(3), 1, 0, 0, D3DSWAPEFFECT_DISCARD, 0, 1, 0, 0, 0, 0, 0
	p = 0
	d3d9err=0
	vsyncoff=0
	if (BMSCR(17) = 1) {vsyncoff=1: gosub  *timeinit: return -6 }	//݂̑悪buffer
	if varptr(Direct3DCreate9) = 0 {vsyncoff=1: gosub  *timeinit: return -1 }	 //Direct3DCreate9̂Ń^C}[[hݒ肵ďI
	newcom objd3d, , -1, Direct3DCreate9(D3D_SDK_VERSION)
	
	D3D9_GetAdapterDisplayMode objd3d, 0, varptr(D3DFORMAT)	

	if D3DFORMAT(2)>0 {RefreshRate=D3DFORMAT(2)}//tbV[gǂݎȂꍇ60ݒ
	if _set_fps<=0 {set_fps=RefreshRate}//t[[g0ȉw肳ꂽ̂ŃtbV[gt[[g
	
	D3D9_GetDeviceCaps objd3d,0,D3DDEVTYPE_HAL,varptr(D3DCAPS9)
	if stat<0 {
		D3D9_GetDeviceCaps objd3d,0,D3DDEVTYPE_REF,varptr(D3DCAPS9)//D3DDEVTYPE_REFDDCAPS_READSCANLINEɑΉĂȂ
		if stat<0 {d3d9err=stat:vsyncoff=1: gosub  *timeinit: return -2} //D3D9_GetDeviceCapss
	}

	if (D3DCAPS9(2)&DDCAPS_READSCANLINE) = 0 {vsyncoff=1: gosub  *timeinit: return -3} //擾Ή̏ꍇ^C}[[hݒ
	
	FPUtes=str(9876543210.98745+1)
	FPU=(peek(FPUtes,15) = '5') //݂FPUxeXgA_ȉ'5'ǂݎȂPx
	bgscr D3D9WIN_ID,1,1,2
	
	BF_SV=D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_FPU_PRESERVE*FPU //łSOFTWAREɂ
	D3D9_CreateDevice objd3d, 0, D3DCAPS9 , hWnd, BF_SV, varptr(d3dpp), varptr(p)
	d3d9err=stat
	
	gsel bak_ID 

	if 	d3d9err<0{ vsyncoff=1:gosub  *timeinit: return -4} //D3D9_CreateDevices
	newcom objd3ddv, , -1, p
		
	if vsyncon=0 {//Ď[hDtOOFF
		if set_fps ! RefreshRate {//wt[[gƃtbV[gႤꍇ^C}[[hݒ
			vsyncoff=2: gosub  *timeinit: return -5 //^C}[[hI
		}
	}else{ //Ď[hDtOON@wt[[gƃtbV[g^C}[[h+Ď[hݒ
		if (set_fps = RefreshRate) {vsyncon=0}//Ȃʏ̑Ď[hݒ
	}

	gosub  *timeinit

return RefreshRate 

*timeinit
	Refresh_time=1000.0/RefreshRate
	fps_time=1000.0/set_fps
	timA=_timeGetTime()
	Start_tim=timA
	timB=timA
	timC=timA
	fs_tim=0.0
	cpu10=0.0
	cpu=0.0
	Processing_time=0
	Processing_time10=0
return	

//GetRasterStatus AԃtO, 
//擾
#deffunc GetRasterStatus var V,var R //擾
	if (vsyncoff\2)=0 {
		IDirect3DDevice9_GetRasterStatus objd3ddv,0,varptr(RasterStatus)
		V=RasterStatus //1=AԒ
		R=RasterStatus(1) //݂̑Aオ1̎0ɂȂ(ɂ邩mȂ)
	}
return 

#define  D3DERR_DEVICELOST  -2005530520
#define  D3DERR_DEVICENOTRESET  -2005530519

//d3d9vsync ĎtO
//  tO1w肷ƃ^C}[[hiȗ0Ď[hj
#deffunc d3d9vsync int _vsyncoff
	fps_cnt++
	mref BMSCR,67
	
	if ginfo(2)<0 or (ginfo(3) ! Target_ID) or (BMSCR(17) = 1) or (desktop_sizey ! ginfo(21))  {//ANeBuɂȂA𑜓xύXꂽÃEBhEƈA悪buffer
		Reset_f=1  //D3DDV9ZbgtOZbg
	}else{
		if Reset_f=1 { //ZbgtOĂ1t[o߂
			Reset_f=2 //ZbgtOZbgiANeBuɂȂĂ1t[҂߁j
		}else{
			if Reset_f=2  {//ZbgtOĂ
				D3D9_TestCooperativeLevel objd3ddv
				if D3DERR_DEVICENOTRESET=stat or stat=0 {//Zbg\
					D3DDV9_Reset 
					Reset_f=0
				}

			}
		}
	}
	
	to=t
	Rasterok_f=0
	Processing_time10+Processing_time
	if (fps_cnt\10)=0 {cpu10=(double(Processing_time10)*10)/fps_time:Processing_time10=0}
	cpu=double(Processing_time*100)/fps_time
	desktop_sizey=ginfo(21)
	adjust=((60.0/double(RefreshRate))*(double(desktop_sizey)/1080))//𑜓xƃtbV[gɂ1C̎Ԃς̂ŌWo
	Raster_ms=double(desktop_sizey)/Refresh_time//1msňړ鑖
	if (ginfo(7)<ginfo(21)) and (ginfo(7)>0) {WinRaster=ginfo(7)}else{WinRaster=ginfo(21)}//EBhEʒuƃfXNgbvxTCYrĒႢX^[rʒuɂ
	dup Raster,RasterStatus(1)
	WinUpRaster=limit(ginfo(5)-adjust*10,0,ginfo(5))
	
	if (_vsyncoff | vsyncoff | Reset_f)=0 and vsyncon=0	{ //ĎON
		if ginfo(13)>=ginfo(21) {Sleep_adjust=Sleep_adjust_full } //tXN[X[vCl
		timA = _timeGetTime()
		Processing_time = timA - timB //OĎJň݂܂ł̌oߎ(ĎԂ܂܂邩烁CԂ1msx]ɂȂ)
		sleep_tim=limit(fps_time-((timA - timC))-Sleep_adjust,0,fps_time)//X[vԁiOĎʒu𒴂Sleep_adjustZj
		if sleep_tim>0 {_Sleep sleep_tim}//X[v

		timB=_timeGetTime()
		if ginfo(13)>=ginfo(21) {//EBhETCYfXNgbvTCYȏitXN[ƂďJnj
			_WinRaster=WinRaster-(adjust*Raster_adjust)
			IDirect3DDevice9_GetRasterStatus objd3ddv,0,varptr(RasterStatus)
			if   RasterStatus=1 or Raster=0 or  (Raster>=_WinRaster) {
				
			}else{
				Raster_bak=Raster
				repeat
					IDirect3DDevice9_GetRasterStatus objd3ddv,0,varptr(RasterStatus)
					if   RasterStatus=1 or Raster=0 or  (Raster>=_WinRaster) {Rasterok_f=1:break}
					if (cnt\100)=99 {if Raster_bak=Raster{break}else{Raster_bak=Raster}}//[vi100񃋁[vĂ甲jKvȂ낤ǁEEE
				loop
			}
		}else{
			IDirect3DDevice9_GetRasterStatus objd3ddv,0,varptr(RasterStatus)
			if Raster>=WinRaster {
				Sleep_adjust=limit((Raster+Raster_ms-WinRaster)/Raster_ms,1,fps_time)//X[vIシɊĎʒuzĂ̂Ŏ̃X[vZCl
			}else{
				Sleep_adjust=0
				Raster_bak=Raster
				repeat
					IDirect3DDevice9_GetRasterStatus objd3ddv,0,varptr(RasterStatus)
					if   (RasterStatus=1 or Raster=0 or Raster>=WinRaster) {Rasterok_f=1:break}
					if (cnt\100)=99 {if Raster_bak=Raster{break}else{Raster_bak=Raster}}
				loop
			}
		}
		fs_tim=0.0
		timC=_timeGetTime()
		Start_tim=timC
	}else{ //^C}[ON

		fs_tim+fps_time //1t[̎Ԃ𑫂Ďt[X^[gԂɂ
		if fs_tim > 50 {Start_tim+50:fs_tim-50} //HSPDXgp͒PxɂȂ邩猅}
		timB=_timeGetTime()
		sms=fs_tim-(timB-Start_tim) //t[X^[gԂX^[g̎ԂăX[vԂɂiʂȂ1t[̎Ԃzj
		if sms < 0 {fs_tim-sms} //1t[̎ԈȏgpI[o[t[X^[gԂɉZ
		_Sleep limit(sms,0,fps_time+1) //_ȉ̃X[v͏oȂőX[vԂ+1
		if (vsyncoff\2)=0 and Reset_f=0	{gosub *GetRaster}//GetRasterStatusgȂg
		Processing_time=timB-timC//1t[̃X[vԂ𔲂ԁiɊ|ԁj
		timC=_timeGetTime()
	}
	t=timC/1000
	if t ! to {d3d9vsync_fps=fps_cnt-fps_cnt_old:fps_cnt_old=fps_cnt}
return Rasterok_f //ꂪ1̏ꍇX[vԂȂi擾ɑΉĂꍇj

*GetRaster
	IDirect3DDevice9_GetRasterStatus objd3ddv,0,varptr(RasterStatus)
	if   (Raster<=WinUpRaster or Raster>=WinRaster) {//CEBhEOȂ甲
		return
	}else{
		if _vsyncoff>0 or vsyncon=0 {Rasterok_f=1:return }//^C}[[hȂ̂łɔ
		Raster_bak=Raster
		repeat
			IDirect3DDevice9_GetRasterStatus objd3ddv,0,varptr(RasterStatus)
			if   (Raster<=_WinRaster or Raster>=WinRaster) {Rasterok_f=1:break}
			if (cnt\100)=99 {if Raster_bak=Raster{break}else{Raster_bak=Raster}}
		loop
	}		
return

//d3d9vsync_end
//d3d9vsyncI
#deffunc d3d9vsync_end onexit
	if tBP {_timeEndPeriod 1:tEP=0}
	if vartype(objd3ddv)=6 {delcom objd3ddv:objd3ddv=0}
	if vartype(objd3d)=6 {delcom objd3d:objd3d=0}
return

//d3d9vsync_logsave
//Oۑ
#deffunc d3d9vsync_logsave
	D3DCAPS9_log="-------------------------------\n	D3DDISPLAYMODE\n-------------------------------\n"
	repeat 4
		D3DCAPS9_log+=strf("%2d :  %d\n",cnt,D3DFORMAT(cnt))
	loop
	D3DCAPS9_log+"\n-------------------------------\n	D3DCAPS9\n-------------------------------\n"
	repeat 76
		if cnt=62 {D3DCAPS9_log+"D3DVSHADERCAPS2_0 VS20Caps{\n"}
		if cnt=66 {D3DCAPS9_log+"D3DPSHADERCAPS2_0 PS20Caps{\n"}
		D3DCAPS9_log+=strf("%2d :  %s",cnt,str(D3DCAPS9(cnt)))
		if cnt=49 {D3DCAPS9_log+strf("   VertexShaderVersion(%d,%d)",D3DVP_VERSION(D3DCAPS9(cnt)))}
		if cnt=51 {D3DCAPS9_log+strf("   PixelShaderVersion(%d,%d)",D3DVP_VERSION(D3DCAPS9(cnt)))}	
		if cnt=65 or cnt=69 {D3DCAPS9_log+"\n	}\n"}else{D3DCAPS9_log+"\n"}
	loop
	D3DCAPS9_log+"\n-------------------------------\n	D3DPRESENT_PARAMETERS\n-------------------------------\n"
	repeat 14
		D3DCAPS9_log+=strf("%2d :  %d\n",cnt,d3dpp(cnt))
	loop
	notesel D3DCAPS9_log
	notesave  "d3d9vsync.log"
return

#global